package com.fp.persistence.pgeneral.gene;

import java.io.Serializable;
import java.lang.reflect.Field;
import java.sql.Date;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import javax.persistence.Table;
import javax.persistence.Transient;

import org.hibernate.SQLQuery;
import org.hibernate.Session;

import com.fp.dto.hb.HibernateBean;

/** Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENETELLERTRANSFER */
@Entity(name = "TgeneTellerTransfer")
@Table(name = "TGENETELLERTRANSFER")
public class TgeneTellerTransfer extends com.fp.dto.AbstractDataTransport
		implements
			Serializable,
			HibernateBean,
			Cloneable {
	/**
	 * HashCode asociado con la Instancia
	 */
	@Transient
	private int hashValue = 0;
	/**
	 * Version de la Clase
	 */
	private static final long serialVersionUID = 1L;
	/**
	 * Clave primaria de la Entidad TgeneTellerTransfer
	 */
	@EmbeddedId
	private TgeneTellerTransferKey pk;
	/** Contructor por defecto */
	public TgeneTellerTransfer() {
	}
	/**
	 * Contructor de TgeneTellerTransfer
	 * 
	 * @param pPk Clave Primaria del entity
	 */
	public TgeneTellerTransfer(TgeneTellerTransferKey pPk) {
		this();
		pk = pPk;
	}
	/**
	 * Metodo que entrega datos de la tabla dada la clave primaria.
	 * 
	 * @param pEntityManager referencia de la session a obtener datos del bean.
	 * @param pKey Caleve primaria del bean.
	 * @return TgeneTellerTransfer
	 */
	public static TgeneTellerTransfer find(EntityManager pEntityManager, TgeneTellerTransferKey pKey) throws Exception {
		TgeneTellerTransfer obj = pEntityManager.find(TgeneTellerTransfer.class, pKey);
		return obj;
	}
	/**
	 * Entrega la Clave primaria de TgeneTellerTransfer
	 * 
	 * @return El objeto que referencia a la Clave primaria de TgeneTellerTransfer
	 */
	public TgeneTellerTransferKey getPk() {
		return pk;
	}
	/**
	 * Fija un nuevo valor a la Clave primaria de TgeneTellerTransfer
	 * 
	 * @param pPk El objeto que referencia a la nueva Clave primaria de TgeneTellerTransfer
	 */
	public void setPk(TgeneTellerTransferKey pPk) {
		pk = pPk;
	}
	public boolean equals(Object rhs) {
		if (rhs == null)
			return false;
		if (!(rhs instanceof TgeneTellerTransfer))
			return false;
		TgeneTellerTransfer that = (TgeneTellerTransfer) rhs;
		if (this.getPk() == null || that.getPk() == null)
			return false;
		return (this.getPk().equals(that.getPk()));
	}
	/**
	 * Implementación del metodo hashCode de la la entidad TgeneTellerTransfer
	 * 
	 * @return el hashCode la instancia
	 */
	public int hashCode() {
		if (this.hashValue == 0) {
			int result = 17;
			if (this.getPk() == null) {
				result = super.hashCode();
			} else {
				result = this.getPk().hashCode();
			}
			this.hashValue = result;
		}
		return this.hashValue;
	}
	/** Implementación toString */
	public String toString() {
		Field[] fs = this.getClass().getDeclaredFields();
		String data = "";
		for (Field f : fs) {
			try {
				String name = f.getName();
				if (f.getType().getName().compareTo("java.util.Set") == 0)
					continue;
				if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0)
					continue;
				data += name + "=" + f.get(this) + ";";
			} catch (Exception e) {
				continue;
			}
		}
		if (data.compareTo("") == 0) {
			data = super.toString();
		}
		return data;
	}
	/** Implementación de la creación de un bean en blanco TgeneTellerTransfer */
	public Object createInstance() {
		TgeneTellerTransfer instance = new TgeneTellerTransfer();
		instance.setPk(new TgeneTellerTransferKey());
		return instance;
	}
	/**
	 * Clona la entidad TgeneTellerTransfer
	 * 
	 * @see com.fp.dto.hb.HibernateBean#cloneMe()
	 */
	public Object cloneMe() throws CloneNotSupportedException {
		TgeneTellerTransfer p = (TgeneTellerTransfer) this.clone();
		p.setPk((TgeneTellerTransferKey) this.pk.cloneMe());
		return p;
	}
	//Metodos manuales.
	
    /**sentencia que elimina TgeneTellerTransfer*/
    private static final String DEL_TRANSF =
            " delete from TGENETELLERTRANSFER t "
            + " where t.WORKINGDATE = :workingdate "
            + " and t.USERCODE = :usercode "
            + " and t.TRANSFERNUMBER = :transfernumber";
    
    /**
     * Elimina un registro de la tabla para el usuario, fecha de trabajo y numero de transferencia.
     * @param pEntityManager  Referencia la session de la base de datos.
     * @param pWorkingdate  Fecha de trabajo.
     * @param pUser  Codigo de usuario.
     * @param pTransfernumber  Numero de transferencia. 
     * @throws Exception
     */
    public static void delete(EntityManager pEntityManager,Date pWorkingdate,String pUser,Integer pTransfernumber) throws Exception {
    	//Elimina TgeneTellerTransfer
    	Session s =  (Session)pEntityManager.getDelegate();
        SQLQuery sqldet = s.createSQLQuery(DEL_TRANSF);
        sqldet.setDate("workingdate", pWorkingdate);
        sqldet.setString("usercode", pUser);
        sqldet.setInteger("transfernumber", pTransfernumber);
        sqldet.executeUpdate();
    }
    
    /**sentencia que obtiene la secuencia por fecha de trabajo, usuario.*/
    private static final String SQL = "select coalesce( max(TRANSFERNUMBER),0) from TGENETELLERTRANSFER "
            + " where WORKINGDATE = :workingdate and USERCODE = :usercode ";
    
    /**
     * Entrega la secuencia de transferencia.
     * @param pWorkingDate  Fecha de trabajo.
     * @param pUsercode  Codigo de usuario.
     * @return  Integer
     * @throws Exception
     */
    public static Integer getTransfernumber(EntityManager pEntityManager,Date pWorkingDate, String pUsercode) throws Exception {
        Integer transfernumber = null;
        Session s =  (Session)pEntityManager.getDelegate();
        SQLQuery sql = s.createSQLQuery(SQL);
        sql.setDate("workingdate", pWorkingDate);
        sql.setString("usercode", pUsercode);
        transfernumber = Integer.parseInt(sql.uniqueResult().toString());
        transfernumber++;
        return transfernumber;
    }
    

    
}
